// ==== Standard POV-Ray Includes ====
#include "colors.inc"	  // Standard Color definitions
#include "textures.inc"	  // Standard Texture definitions
#include "functions.inc"  // internal functions usable in user defined functions
#include "transforms.inc"
#include "strings.inc"


fog{
        distance 30
        color rgb 0.7*<0.6,0.6,0.95>
}


#default { finish { ambient 0.35} }
background {color rgb 0}


light_source {
  0                    // light's position (translated below)
  color rgb 1.      // light's color
  translate <20,20,-18>
  spotlight
  // parallel
  point_at <0,3,0>
}

light_source {
  0
  color rgb 0.6
  translate <-20,-5,-2>
}


plane {y,-5
	pigment {color White}
}
cylinder {<0,-1,0>, <0,10,0>, 6
  scale <0.6,1,1>
  translate <-8,0,6> 
  pigment {color rgb 0.6}
}

#declare maxLine = 18;

#declare vertex = array[maxLine][maxLine];

#declare n = 2*clock;

#declare _U = 0;

#while (_U<maxLine)
  #declare _V = 0;
  #while (_V<maxLine)
  	#declare U = _U/maxLine;
  	#declare V = _V/maxLine;
  	#declare vertex[_U][_V] = 0.7* (cos (n*pi) * <sinh((1.6)*(2*V-1))*sin((2*U-1)*pi),
  						  -sinh((1.6)*(2*V-1))*cos((2*U-1)*pi),
  						   pi*(2*U-1)> +
		       	     	     		   sin (n*pi) * <cosh((1.6)*(2*V-1))*cos((2*U-1)*pi),
		       	     	     		   cosh((1.6)*(2*V-1))*sin((2*U-1)*pi),
		       	     	     		   1.6*(2*V-1)>) +<0,5,2>;
  	#declare _V = _V +1;
  #end
  //#debug concat(Str(_U),"\n")
  #declare _U = _U +1;  
	
#end

//#fopen outfile "./helicat.inc" write

#declare _u = 0;
#while (_u < maxLine -1)
  #declare _v = 0;
  #while (_v< maxLine -1)
  	triangle {vertex[_u][_v], vertex[_u+1][_v], vertex[_u+1][_v+1] pigment {White} }
  	triangle {vertex[_u][_v], vertex[_u][_v+1], vertex[_u+1][_v+1] pigment {White} }
  	//#write (outfile, "triangle {<", vertex[_u][_v],vertex[_u+1][_v], vertex[_u+1][_v+1],">\n")
	  //#write (outfile, "triangle {<", vertex[_u][_v],vertex[_u][_v+1], vertex[_u+1][_v+1],">\n")
  	
  	#declare _v = _v +1;
  #end 
  //#debug concat (Str(_u),"\n")
  #declare _u = _u+1;
#end

#ifndef (szgpovCam)
// perspective (default) camera
camera {
  location  <0,4,-18>
  look_at <0,3,0>
  right     x*image_width/image_height
}
#end
